package jp.gr.java_conf.davinche.notepad.ar;

import jp.gr.java_conf.davinche.notepad.database.NotepadDto;
import jp.gr.java_conf.davinche.notepad.database.NotepadSqLiteHelper;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.widget.FrameLayout;

public class AroundMemoActivity extends Activity {

  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);

    // ʂɒǉ郁ID擾
    Intent data = getIntent();
    Bundle extras = data.getExtras();
    if (extras == null) {
      Log.e("AroundCamera", "note id is null");
      return;
    }

    NotepadSqLiteHelper helper = new NotepadSqLiteHelper(this);
    SQLiteDatabase db = helper.getWritableDatabase();

    String noteId = extras.getString("id");
    if (noteId == null) {
      Log.e("AroundCamera", "note id is null");
      return;
    }

    String[] columns = {
        "id", "title", "content"
    };
    Cursor cursor = db.query("notepad", columns, "id = " + noteId, null, null, null, "id");
    NotepadDto dto = new NotepadDto();
    while (cursor.moveToNext()) {
      dto.setId(cursor.getString(0));
      dto.setTitle(cursor.getString(1));
      dto.setContent(cursor.getString(2));
    }
    db.close();

    FrameLayout frameLayout = new FrameLayout(this);
    setContentView(frameLayout);

    // J\pView̐ݒ
    AroundMemoView aroundMemoView = new AroundMemoView(this, dto);
    frameLayout.addView(aroundMemoView);

  }
}
