package jp.gr.java_conf.davinche.notepad.ar;

import android.app.Activity;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PorterDuff.Mode;
import android.graphics.RectF;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

/**
 * \郁P̃r[
 */
public class AroundMemoUnitView extends View implements SensorEventListener, OnTouchListener {

  // [猩̈ʒuFʊp
  private float memoAzimuth;

  // [猩̈ʒuF]p
  private float memoRoll;

  // J\ƃ̊pxF
  private float memoAngleX;

  // J\ƃ̊pxF
  private float memoAngleY;

  // ZT[擾Fʊp
  private float sensorAzimuth;

  // ZT[擾F]p
  private float sensorRoll;

  // e
  private String note;

  // 폜p
  private RectF backGroundRect;

  private Canvas canvas;

  private boolean valid;

  private int x = -1;

  private int y = -1;

  private boolean initializeAzimuthRoll = false;

  // private Context context;

  public AroundMemoUnitView(Activity context, String note, int x, int y) {
    super(context);
    this.x = x;
    this.y = y;
    initializeAzimuthRoll = false;
    init(context, note);
  }

  private void init(Activity context, String note) {
    this.note = note;
    // this.context = context;

    // ZT[}l[W[擾
    SensorManager sensorManager = (SensorManager) context.getSystemService(Context.SENSOR_SERVICE);

    // ZT[Xi[o^
    // X
    sensorManager
        .registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION), SensorManager.SENSOR_DELAY_NORMAL);

    // x
    sensorManager.registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER),
        SensorManager.SENSOR_DELAY_NORMAL);

    // ʃ^b`̃Xi[ݒ
    this.setOnTouchListener(this);

    valid = true;
  }

  private void createAngle() {

    if ((360 - 45) < sensorAzimuth && memoAzimuth < 45) {
      memoAngleX = (memoAzimuth + 360) - sensorAzimuth;
    } else if ((360 - 45) < memoAzimuth && sensorAzimuth < 45) {
      memoAngleX = (memoAzimuth - 360) - sensorAzimuth;
    } else {
      memoAngleX = memoAzimuth - sensorAzimuth;
    }

    memoAngleY = Math.abs(memoRoll) - Math.abs(sensorRoll);

    // ʊȌꍇ\
    if (Math.abs(memoAngleX) < 45 && memoAngleY < 45) {
      valid = note != null;
    } else {
      valid = false;
    }
  }

  @Override
  protected void onDraw(Canvas canvas) {
    super.onDraw(canvas);
    this.canvas = canvas;
    if (valid) {
      // J̏񂩂XYvZ
      double centerCapRateX = memoAngleX / 45;
      double centerGapX = canvas.getWidth() / 2.0 * centerCapRateX;
      x = (int) (canvas.getWidth() / 2 + centerGapX);

      double centerGapRateY = memoAngleY / 45 * -1.0;
      double centerGapY = canvas.getHeight() / 2.0 * centerGapRateY;
      y = (int) (canvas.getHeight() / 2 + centerGapY);

      drawText(canvas, x, y);
    }
  }

  private void drawText(Canvas canvas, int x, int y) {
    // sR[hŐ؂
    String[] notes = note.split("\n");

    int lineCount = 0;
    int fontSize = 25;

    // Ŝ̕vZ
    float textX = 0;
    float textWidth = 0;
    for (String note : notes) {
      // ԉ̒̂XWƉ擾
      Paint paint = new Paint(Paint.ANTI_ALIAS_FLAG);
      paint.setTextSize(fontSize);
      float width = paint.measureText(note);

      if (textWidth < width) {
        textWidth = width;
        textX = x - textWidth / 2;
      }
    }

    // \yWeLXgsƂɌvZȂ
    y -= notes.length / 2 * fontSize;

    // o̍WB5|CgO͂
    float textStartX = textX - 5;
    float textEndX = textX + textWidth + 10;
    float textStartY = y - 5 - fontSize;
    float textEndY = y + 5 + (fontSize * notes.length);

    // wi̕`
    Paint backGround = new Paint(Paint.ANTI_ALIAS_FLAG);
    backGround.setTextSize(fontSize);
    backGround.setColor(Color.BLACK);
    backGroundRect = new RectF(textStartX, textStartY, textEndX, textEndY);
    canvas.drawRoundRect(backGroundRect, 0, 0, backGround);

    // wȉɕ`悷
    for (String note : notes) {
      Paint paint = new Paint(Paint.ANTI_ALIAS_FLAG);
      paint.setTextSize(fontSize);
      paint.setColor(Color.WHITE);

      // ̍YWvZ
      float textY = y + (lineCount * (fontSize + 2));

      canvas.drawText(note, textX, textY, paint);
      lineCount++;
    }
    // ^b`ł悤ɔ͈͂L
    backGroundRect = new RectF(textStartX - 50, textStartY - 50, textEndX + 50, textEndY + 50);
  }

  @Override
  public void onAccuracyChanged(Sensor arg0, int arg1) {
  }

  @Override
  public void onSensorChanged(SensorEvent event) {
    if (event.sensor.getType() == Sensor.TYPE_ORIENTATION) {
      // 
      sensorAzimuth = event.values[SensorManager.DATA_X];

      // ]
      sensorRoll = event.values[SensorManager.DATA_Y];

      if (!initializeAzimuthRoll) {
        // ̕ʓ
        this.memoAzimuth = sensorAzimuth;
        this.memoRoll = sensorRoll;
        initializeAzimuthRoll = true;
      }

    }

    createAngle();
    super.invalidate();
  }

  @Override
  public boolean onTouch(View view, MotionEvent event) {

    // ^b`ꂽ|WV̎擾
    int x = (int) event.getRawX();
    int y = (int) event.getRawY();

    if (isHit(x, y)) {
      // `IDBf[^NA
      canvas.drawColor(0, Mode.CLEAR);
      valid = false;
      note = null;
      invalidate();
    }

    return false;
  }

  public boolean isHit(int x, int y) {
    return valid && note != null && backGroundRect.contains(x, y);
  }
}
