package jp.gr.java_conf.davinche.notepad.input;

import jp.gr.java_conf.davinche.notepad.R;
import jp.gr.java_conf.davinche.notepad.ar.AroundMemoActivity;
import jp.gr.java_conf.davinche.notepad.database.NotepadDto;
import jp.gr.java_conf.davinche.notepad.database.NotepadSqLiteHelper;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.EditText;

public class InputActivity extends Activity {

  private String noteId;

  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.input);

    NotepadSqLiteHelper helper = new NotepadSqLiteHelper(this);
    SQLiteDatabase db = helper.getWritableDatabase();

    // 
    Intent data = getIntent();
    Bundle extras = data.getExtras();
    if (extras != null) {
      noteId = extras.getString("id");

      String[] columns = {
          "id", "title", "content"
      };
      Cursor cursor = db.query("notepad", columns, "id = " + noteId, null, null, null, "id");
      NotepadDto dto = new NotepadDto();
      while (cursor.moveToNext()) {
        dto.setId(cursor.getString(0));
        dto.setTitle(cursor.getString(1));
        dto.setContent(cursor.getString(2));
      }
      db.close();

      EditText title = (EditText) findViewById(R.id.title);
      title.setText(dto.getTitle());

      EditText content = (EditText) findViewById(R.id.content);
      content.setText(dto.getContent());

      Button button = (Button) findViewById(R.id.register);
      button.setText(R.string.update);

      // {^̃Xi[
      button.setOnClickListener(new InputUpdateListener(this, dto));
    } else {
      // {^̃Xi[
      Button registerButton = (Button) findViewById(R.id.register);
      registerButton.setOnClickListener(new InputRegisterListener(this));
    }
  }

  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    if (noteId != null) {
      menu.add(Menu.NONE, Menu.FIRST, Menu.NONE, "E");
    }
    return super.onCreateOptionsMenu(menu);
  }

  @Override
  public boolean onOptionsItemSelected(MenuItem item) {

    switch (item.getItemId()) {
      case Menu.FIRST:
        // E̋N
        Intent intent = new Intent(this, AroundMemoActivity.class);
        intent.putExtra("id", noteId);
        this.startActivityForResult(intent, 1);
        return true;
    }

    return super.onOptionsItemSelected(item);
  }
}
