package jp.gr.java_conf.davinche.notepad.input;

import jp.gr.java_conf.davinche.notepad.R;
import jp.gr.java_conf.davinche.notepad.database.NotepadSqLiteHelper;
import android.app.Activity;
import android.content.ContentValues;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.Toast;

public class InputRegisterListener implements OnClickListener {

  private Activity activity;

  public InputRegisterListener(Activity activity) {
    this.activity = activity;
  }

  @Override
  public void onClick(View v) {
    // ͍ڂ̏擾
    EditText titleEdit = (EditText) activity.findViewById(R.id.title);
    EditText contentEdit = (EditText) activity.findViewById(R.id.content);

    NotepadSqLiteHelper helper = new NotepadSqLiteHelper(activity);
    SQLiteDatabase db = helper.getWritableDatabase();

    String title = titleEdit.getText().toString();
    String content = contentEdit.getText().toString();

    // K{`FbN
    boolean valid = true;
    if (title == null || title.equals("")) {
      Toast.makeText(activity, "^Cg͕K͂ĂB", Toast.LENGTH_LONG).show();
      valid = false;
    } else if (content == null || content.equals("")) {
      Toast.makeText(activity, "e͕K͂ĂB", Toast.LENGTH_LONG).show();
      valid = false;
    }

    if (!valid) {
      return;
    }

    // o^pDB̍쐬
    try {
      String createSql = "create table notepad(id integer primary key autoincrement, title text not null, content text not null)";
      db.execSQL(createSql);
    } catch (Exception e) {
    } finally {
    }

    // ڂ̓o^
    try {
      db.beginTransaction();
      ContentValues val = new ContentValues();
      val.put("title", title);
      val.put("content", content);

      db.insert("notepad", null, val);

      db.setTransactionSuccessful();
      db.endTransaction();

      Toast.makeText(activity, "o^܂", Toast.LENGTH_SHORT).show();

      // o^Aꗗʂ֑J
      activity.finish();

    } catch (Exception e) {
      Toast.makeText(activity, "o^Ɏs܂", Toast.LENGTH_SHORT).show();
      Log.e("ERROR", "insert table is failed", e);
    } finally {
      db.close();
    }

  }

}
