package jp.gr.java_conf.davinche.notepad.input;

import jp.gr.java_conf.davinche.notepad.R;
import jp.gr.java_conf.davinche.notepad.database.NotepadDto;
import jp.gr.java_conf.davinche.notepad.database.NotepadSqLiteHelper;
import jp.gr.java_conf.davinche.notepad.widget.OpenNotepadAction;
import android.app.Activity;
import android.appwidget.AppWidgetManager;
import android.content.ContentValues;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.Toast;

public class InputUpdateListener implements OnClickListener {

  private Activity activity;

  private NotepadDto dto;

  public InputUpdateListener(Activity activity, NotepadDto dto) {
    this.activity = activity;
    this.dto = dto;
  }

  @Override
  public void onClick(View v) {
    // ͍ڂ̏擾
    EditText titleEdit = (EditText) activity.findViewById(R.id.title);
    EditText contentEdit = (EditText) activity.findViewById(R.id.content);

    NotepadSqLiteHelper helper = new NotepadSqLiteHelper(activity);
    SQLiteDatabase db = helper.getWritableDatabase();

    String title = titleEdit.getText().toString();
    String content = contentEdit.getText().toString();

    // K{`FbN
    boolean valid = true;
    if (title == null || title.equals("")) {
      Toast.makeText(activity, "^Cg͕K͂ĂB", Toast.LENGTH_LONG).show();
      valid = false;
    } else if (content == null || content.equals("")) {
      Toast.makeText(activity, "e͕K͂ĂB", Toast.LENGTH_LONG).show();
      valid = false;
    }

    if (!valid) {
      return;
    }

    // ڂ̓o^
    try {
      db.beginTransaction();
      ContentValues val = new ContentValues();
      val.put("title", title);
      val.put("content", content);

      String condition = "id = ?";

      db.update("notepad", val, condition, new String[] {
        dto.getId()
      });

      db.setTransactionSuccessful();
      db.endTransaction();

      Toast.makeText(activity, "XV܂", Toast.LENGTH_SHORT).show();
    } catch (Exception e) {
      Log.e("ERROR", "update table is failed", e);
    } finally {
      db.close();
    }

    // EBWFbgXV
    Intent widgetUpdate = new Intent();
    widgetUpdate.putExtra(OpenNotepadAction.NOTEPAD_CONTENT_ID, dto.getId());
    widgetUpdate.setAction(AppWidgetManager.ACTION_APPWIDGET_UPDATE);
    activity.sendBroadcast(widgetUpdate);

    // o^Aꗗʂ֑J
    activity.finish();
  }
}
