package jp.gr.java_conf.davinche.notepad.list;

import jp.gr.java_conf.davinche.notepad.R;
import jp.gr.java_conf.davinche.notepad.database.NotepadDto;
import jp.gr.java_conf.davinche.notepad.database.NotepadSqLiteHelper;
import android.app.Activity;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.widget.Button;
import android.widget.ListView;

public class ListActivity extends Activity {

  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.list);

    ContentAdapter adapter = new ContentAdapter(this, android.R.layout.simple_list_item_1);
    initializeNotepadItems(adapter);

    ListView listView = (ListView) findViewById(R.id.titleList);
    listView.setAdapter(adapter);

    // XgĨXi[
    listView.setOnItemClickListener(new SelectItemListener(this));
    listView.setOnItemLongClickListener(new ListDeleteListener(this));

    // {^̃Xi[
    Button newRegisterButton = (Button) findViewById(R.id.new_register);
    newRegisterButton.setOnClickListener(new ListMoveNewRegisterListener(this));
  }

  public void initializeNotepadItems(ContentAdapter adapter) {
    // Adapter̃NA
    adapter.clear();

    NotepadSqLiteHelper helper = new NotepadSqLiteHelper(this);
    SQLiteDatabase db = helper.getReadableDatabase();
    // ڂ̓o^
    try {
      String[] columns = {
          "id", "title", "content"
      };
      Cursor cursor = db.query("notepad", columns, null, null, null, null, "id");
      while (cursor.moveToNext()) {
        NotepadDto dto = new NotepadDto();
        dto.setId(cursor.getString(0));
        dto.setTitle(cursor.getString(1));
        dto.setContent(cursor.getString(2));

        adapter.add(dto);
      }
    } catch (Exception e) {
    } finally {
      db.close();
    }
  }

}
