package jp.gr.java_conf.davinche.notepad.list;

import jp.gr.java_conf.davinche.notepad.R;
import jp.gr.java_conf.davinche.notepad.database.NotepadDto;
import jp.gr.java_conf.davinche.notepad.database.NotepadSqLiteHelper;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ListView;
import android.widget.Toast;

public class ListDeleteListener implements OnItemLongClickListener {

  private ListActivity activity;

  public ListDeleteListener(ListActivity activity) {
    this.activity = activity;
  }

  @Override
  public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
    ListView listView = (ListView) parent;
    NotepadDto dto = (NotepadDto) listView.getItemAtPosition(position);

    // 폜܂H̃_CAO\
    AlertDialog.Builder dialog = new AlertDialog.Builder(activity);
    dialog.setMessage("u" + dto.getTitle() + "v" + "폜܂H");
    dialog.setPositiveButton("͂", new DialogYes(dto));
    dialog.setNegativeButton("", new DialogNo());
    dialog.show();

    return false;
  }

  public class DialogYes implements DialogInterface.OnClickListener {

    private NotepadDto dto;

    public DialogYes(NotepadDto dto) {
      this.dto = dto;
    }

    @Override
    public void onClick(DialogInterface dialog, int which) {
      NotepadSqLiteHelper helper = new NotepadSqLiteHelper(activity);
      SQLiteDatabase db = helper.getWritableDatabase();

      try {
        db.beginTransaction();

        db.delete("notepad", "id=?", new String[] {
          dto.getId()
        });

        db.setTransactionSuccessful();
        db.endTransaction();

        Toast.makeText(activity, "폜܂", Toast.LENGTH_SHORT).show();

        // Xg̍ēǂݍ
        ListView listView = (ListView) activity.findViewById(R.id.titleList);
        activity.initializeNotepadItems((ContentAdapter) listView.getAdapter());

      } catch (Exception e) {
        Log.e("ERROR", "delete table is failed", e);
      } finally {
        db.close();
      }

    }
  }

  public class DialogNo implements DialogInterface.OnClickListener {

    @Override
    public void onClick(DialogInterface dialog, int which) {
    }

  }
}
