package jp.gr.java_conf.davinche.notepad.widget;

import jp.gr.java_conf.davinche.notepad.database.NotepadDto;
import android.app.Activity;
import android.appwidget.AppWidgetManager;
import android.content.Intent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

public class SelectWidgetItemListener implements OnItemClickListener {

  private Activity activity;

  private int mAppWidgetId;

  public SelectWidgetItemListener(Activity activity, int mAppWidgetId) {
    this.activity = activity;
    this.mAppWidgetId = mAppWidgetId;
  }

  @Override
  public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
    ListView listView = (ListView) parent;
    NotepadDto item = (NotepadDto) listView.getItemAtPosition(position);

    AppWidgetManager widgetManager = AppWidgetManager.getInstance(activity);
    TagWidgetProvider.selectContent(activity, widgetManager, mAppWidgetId, item);
    
    Intent result = new Intent();
    result.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, mAppWidgetId);
    activity.setResult(Activity.RESULT_OK, result);
    activity.finish();
  }

}
